/*
 * Copyright (C) 2016 Socionext Inc.
 *
 * SPDX-License-Identifier:	GPL-2.0+
 */

#include "../sc64-regs.h"
#include "../sg-regs.h"
#include "local-init.h"

/* Local code common for LD11 and LD20 */
void uniphier_ldxx_local_init(void)
{
	/* Comment format:    PAD Name -> Function Name */

#if defined(CONFIG_NAND_UNIPHIER)
	sg_set_pinsel(3, 0, 8, 4);	/* XNFWP   -> XNFWP */
	sg_set_pinsel(4, 0, 8, 4);	/* XNFCE0  -> XNFCE0 */
	sg_set_pinsel(5, 0, 8, 4);	/* NFRYBY0 -> NFRYBY0 */
	sg_set_pinsel(6, 0, 8, 4);	/* XNFRE   -> XNFRE */
	sg_set_pinsel(7, 0, 8, 4);	/* XNFWE   -> XNFWE */
	sg_set_pinsel(8, 0, 8, 4);	/* NFALE   -> NFALE */
	sg_set_pinsel(9, 0, 8, 4);	/* NFCLE   -> NFCLE */
	sg_set_pinsel(10, 0, 8, 4);	/* NFD0    -> NFD0 */
	sg_set_pinsel(11, 0, 8, 4);	/* NFD1    -> NFD1 */
	sg_set_pinsel(12, 0, 8, 4);	/* NFD2    -> NFD2 */
	sg_set_pinsel(13, 0, 8, 4);	/* NFD3    -> NFD3 */
	sg_set_pinsel(14, 0, 8, 4);	/* NFD4    -> NFD4 */
	sg_set_pinsel(15, 0, 8, 4);	/* NFD5    -> NFD5 */
	sg_set_pinsel(16, 0, 8, 4);	/* NFD6    -> NFD6 */
	sg_set_pinsel(17, 0, 8, 4);	/* NFD7    -> NFD7 */
	sg_set_iectrl_range(3, 17);

	/* reset NANDC when bootmode_sel is nand only. */
	if(((readl(SG_PINMON0) >> 1) & 0x1f) <= 0x17) {
		u32 tmp;

		tmp = readl(SC_RSTCTRL4);
		tmp &= ~SC_RSTCTRL4_NAND;
		writel(tmp, SC_RSTCTRL4);
		udelay(10);
		tmp |= SC_RSTCTRL4_NAND;
		writel(tmp, SC_RSTCTRL4);
	}

#endif

	/* CHECKME: do we need check defined(CONFIG_ARCH_UNIPHIER_LD20) ? */
#if defined(CONFIG_ARCH_UNIPHIER_LD20) && \
	(defined(CONFIG_AVE_RMII) || !defined(CONFIG_RGMII))
	/* Ether */
	sg_set_pinsel(30, 0, 8, 4);	/* MDC         -> MDC */
	sg_set_pinsel(31, 0, 8, 4);	/* MDIO        -> MDIO */
	sg_set_pinsel(32, 0, 8, 4);	/* MDIO_INL    -> MDIO_INTL */
	sg_set_pinsel(33,15, 8, 4);	/* PHYRSTL     -> PORT36 */
	sg_set_pinsel(34, 1, 8, 4);	/* RGMII_RXCLK -> RMII_REFCLK */
	sg_set_pinsel(35, 1, 8, 4);	/* RGMII_RXD0  -> RMII_RXD0 */
	sg_set_pinsel(36, 1, 8, 4);	/* RGMII_RXD1  -> RMII_RXD1 */
	sg_set_pinsel(37, 1, 8, 4);	/* RGMII_RXD2  -> RMII_RXER */
	sg_set_pinsel(38,15, 8, 4);	/* RGMII_RXD3  -> PORT43 */
	sg_set_pinsel(39, 1, 8, 4);	/* RGMII_RXCTL -> RMII_CRS_DV */
	sg_set_pinsel(40,15, 8, 4);	/* RGMII_TXCLK -> PORT45 */
	sg_set_pinsel(41, 1, 8, 4);	/* RGMII_TXD0  -> RMII_TXD0 */
	sg_set_pinsel(42, 1, 8, 4);	/* RGMII_TXD1  -> RMII_TXD1 */
	sg_set_pinsel(43,15, 8, 4);	/* RGMII_TXD2  -> PORT50 */
	sg_set_pinsel(44,15, 8, 4);	/* RGMII_TXD3  -> PORT51 */
	sg_set_pinsel(45, 1, 8, 4);	/* RGMII_TXCTL -> RMII_TXEN */
	sg_set_iectrl_range(30, 37);
	sg_set_iectrl(39);
	sg_set_iectrl(41);
	sg_set_iectrl(42);
	sg_set_iectrl(45);

	{
		u32 tmp;

		tmp = readl(0x55000024);
		tmp &= ~(0x1 << 6);
		writel(tmp, 0x55000024);	/* P3DIR6: OUT */

		tmp = readl(0x55000020);
		tmp |= (0x1 << 6);
		writel(tmp, 0x55000020);	/* P3IOD6: 1 */
	}
#else
	sg_set_pinsel(30, 0, 8, 4);	/* MDC         -> MDC */
	sg_set_pinsel(31, 0, 8, 4);	/* MDIO        -> MDIO */
	sg_set_pinsel(32, 0, 8, 4);	/* MDIO_INL    -> MDIO_INTL */
	sg_set_pinsel(33, 0, 8, 4);	/* PHYRSTL     -> PHYRSTL */
	sg_set_pinsel(34, 0, 8, 4);	/* RGMII_RXCLK -> RGMII_RXCLK */
	sg_set_pinsel(35, 0, 8, 4);	/* RGMII_RXD0  -> RGMII_RXD0 */
	sg_set_pinsel(36, 0, 8, 4);	/* RGMII_RXD1  -> RGMII_RXD1 */
	sg_set_pinsel(37, 0, 8, 4);	/* RGMII_RXD2  -> RGMII_RXD2 */
	sg_set_pinsel(38, 0, 8, 4);	/* RGMII_RXD3  -> RGMII_RXD3 */
	sg_set_pinsel(39, 0, 8, 4);	/* RGMII_RXCTL -> RGMII_RXCTL */
	sg_set_pinsel(40, 0, 8, 4);	/* RGMII_TXCLK -> RGMII_TXCLK */
	sg_set_pinsel(41, 0, 8, 4);	/* RGMII_TXD0  -> RGMII_TXD0 */
	sg_set_pinsel(42, 0, 8, 4);	/* RGMII_TXD1  -> RGMII_TXD1 */
	sg_set_pinsel(43, 0, 8, 4);	/* RGMII_TXD2  -> RGMII_TXD2 */
	sg_set_pinsel(44, 0, 8, 4);	/* RGMII_TXD3  -> RGMII_TXD3 */
	sg_set_pinsel(45, 0, 8, 4);	/* RGMII_TXCTL -> RGMII_TXCTL */
	sg_set_iectrl_range(30, 45);
#endif
}

